package org.richfaces.realworld.util;

import java.util.ArrayList;
import java.util.List;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Begin;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.richfaces.realworld.domain.Album;
import org.richfaces.realworld.domain.Image;
import org.richfaces.realworld.domain.User;

@Name("friendHelper")
@Scope(ScopeType.CONVERSATION)
public class FriendHelper {

	@Out(required=false)
	private User selectedUser;
	
	@In(required=false) @Out(required=false)
	private Image selectedImage;

	@In(required=false)  @Out(required=false)
	private Album selectedAlbum;
	
	@In(create=true) @Out(required=false)
	private SelectedImageIndex selectedImageIndex;
	
	private String albumName;
	
	public String getAlbumName() {
		return albumName;
	}

	public void setAlbumName(String albumName) {
		this.albumName = albumName;
	}

	public List<String> getFriendAlbums(User friend){
		List<String> albumNames = new ArrayList<String>();
		for(Album album:friend.getChildAlbums()){
			albumNames.add(album.getName());
		}
		return albumNames;
	}
	
	@Begin(join=true)
	public void chooseAlbum(User friend){
		selectedUser = friend;
		selectedAlbum = selectedUser.getAlbumByName(this.getAlbumName());
		selectedImage = selectedAlbum.getImages().get(0);
		selectedImageIndex.setSelectedImageIndex(1);
	}
	
	@Begin(join=true)
	public void chooseAlbum(Album album){
		selectedUser = album.getOwner();
		selectedAlbum = album;
		selectedImage = selectedAlbum.getImages().get(0);
		selectedImageIndex.setSelectedImageIndex(1);
	}
}
